"""
Rotate forward back and saves pictures as ps and as a jpg.
Got a text box.  Need to add return reset and sending to a file.
Could keep the cursor in the text box. 
Now writes sentences to the spinnaker pipe, and looks for files for 
commands from spinnaker.
Try to send the image to the spike server.
"""

#from Tkinter import Tk, Canvas, BOTH
from Tkinter import *
from ttk import Frame, Button, Style
import numpy as np
import math
import Image
from nealParams import *


from toSpikeServe import spikeQueue
from getPixelsClass import imageToPixelClass


class Environment(Frame):
    wordsForward=[0x00000801, # start parse
                  0x0000080B, #move
                  0x00000808, #forward
                  0x0000080C] #period

    wordsBack=[0x00000801, # start parse
                  0x0000080B, #move
                  0x00000802, #back
                  0x0000080C] #period

    wordsLeft=[0x00000801, # start parse
               0x00000815, #turn
               0x0000080A, #left
               0x0000080C] #period

    wordsRight=[0x00000801, # start parse
                0x00000815, #turn
                0x0000080E, #right
                0x0000080C] #period

    wordsMoveLeft=[0x00000801, # start parse
                0x0000080B, #move
                0x0000080A, #left
                0x0000080C] #period

    wordsMoveRight=[0x00000801, # start parse
                0x0000080B, #move
                0x0000080E, #right
                0x0000080C] #period

    wordsTurnPyramid=[0x00000801, # start parse
                0x00000815, #turn
                0x00000814, #toward
                0x00000812, #the
                0x0000080D, #pyramid
                0x0000080C] #period

    numFiles = 0

    gotCommandFromSpinnaker = False


    direction = 0.0
    #camera = np.array([150.0,300.0,0.0,1.0])
    #camera = np.array([150.0,300.0,250.0,1.0]) #close right
    camera = np.array([350.0,300.0,250.0,1.0]) #close left
  
    pyrP1 = np.array([100,400,400,1.0]) 
    pyrP2 = np.array([300.0,400.0,400.0,1.0]) 
    pyrP3 = np.array([300.0,400.0,600.0,1.0])
    pyrP4 = np.array([100.0,400.0,600.0,1.0])
    pyrP5 = np.array([200.0,200.0,500.0,1.0])

    translationMatrix = np.array([[1.0,0.0,0.0,0.0],
                                  [0.0,1.0,0.0,0.0],
                                  [0.0,0.0,1.0,0.0],
                                  [0.0,0.0,0.0,1.0]])


    def __init__(self, parent):
        Frame.__init__(self, parent)   
         
        self.parent = parent        
        self.initUI()

    def forward(self):
        self.toSpinQ.writeSentence(self.wordsForward,4)

    def back(self):
        self.toSpinQ.writeSentence(self.wordsBack,4)

    def left (self):
        self.toSpinQ.writeSentence(self.wordsLeft,4)

    def right (self):
        self.toSpinQ.writeSentence(self.wordsRight,4)

    def processTextInput (self, textInput):
        #clear whitespace before and after
        input = textInput.rstrip()
        input = input.lstrip()

        #test for characters.
        if input.__len__() == 1:
            if input == "r":
                self.toSpinQ.writeSentence(self.wordsRight,4)
            elif input == "l":
                self.toSpinQ.writeSentence(self.wordsLeft,4)
            elif input == "f":
                self.toSpinQ.writeSentence(self.wordsForward,4)
            elif input == "b":
                self.toSpinQ.writeSentence(self.wordsBack,4)
            elif input == "R":
                self.toSpinQ.writeSentence(self.wordsMoveRight,4)
            elif input == "L":
                self.toSpinQ.writeSentence(self.wordsMoveLeft,4)
            elif input == "p":
                self.toSpinQ.writeSentence(self.wordsTurnPyramid,6)
            else:
                print "bad text input ", textInput
        #test for complete sentences
        else:   
            input = input.lower()
            if input == "turn right.":
                self.toSpinQ.writeSentence(self.wordsRight,3)
            elif input == "turn left.":
                self.toSpinQ.writeSentence(self.wordsLeft,3)
            elif input == "move forward.":
                self.toSpinQ.writeSentence(self.wordsForward,3)
            elif input == "move back.":
                self.toSpinQ.writeSentence(self.wordsBack,3)
            elif input == "move right.":
                self.toSpinQ.writeSentence(self.wordsMoveRight,3)
            elif input == "move left.":
                self.toSpinQ.writeSentence(self.wordsMoveLeft,3)
            else:
                print "bad text input ", textInput


    def dumpJPG(self):
        self.canvas.postscript(file="file_name.ps", colormode='color')
        image = Image.open("file_name.ps")
        image.save("temp.jpg","JPEG")
        #self.canvas.save(file="temp.jpg")
            
        print "dumpJPG"

    def putTextInFile(self,text):
        file = open("test.txt","w")
        file.write(text)
        
        print text

    ##-- get actions from spinnaker stored in text files
    def readFromSpin(self):
        fileInName = "data/fromCABot2" + str(self.numFiles) + ".txt"
        
        try:
            self.fileIn = open (fileInName,"rt")
        except IOError, e:
            #print "file not yet created", e  #keep looking for a new file
            if self.gotCommandFromSpinnaker:
                #print "act" , self.toSpinQ.ticksSent
                self.toSpinQ.addConditionalTicks(33)  #100/3 
            if SIM_LENGTH > self.toSpinQ.ticksSent:
                self.after(100,self.readFromSpin)
            return

        fileName = "data/fromCABot2" + str(self.numFiles) + ".txt"
        commandNum = self.fileIn.read()
        self.gotCommandFromSpinnaker = True
        if (commandNum == "0"):
            self.turnRight()
        elif (commandNum == "1"):
            self.turnLeft()
        elif (commandNum == "2"):
            self.moveForward()
        elif (commandNum == "3"):
            self.moveBack()
        else:
            print "bad action ", temp
            
        self.fileIn.close()
        self.numFiles = self.numFiles + 1
        self.after(100,self.readFromSpin)

    def writePictureToSpin(self):
        self.canvas.postscript(file="file_name.ps", colormode='color')
        image = Image.open("file_name.ps")
        image.save("temp.jpg","JPEG")
        toSpinPic = self.imageTranslator.getPixelsFromFile("temp.jpg")
        #9x9off with 30x30 input
        #toSpinPic = [0x00001801,0x00001802,0x00001803,0x00001804,0x00001805, 
                     #0x00001806,0x00001807,0x00001808,0x00001809,
                     #0x0000181F,0x00001820,0x00001821,0x00001822,0x00001823, 
                     #0x00001824,0x00001825,0x00001826,0x00001827, 
                     #0x0000183D,0x0000183E,0x0000183F,0x00001840,0x00001841, 
                     #0x00001842,0x00001843,0x00001844,0x00001845,
                     #0x000018B5,0x000018B6,0x000018B7,0x000018B8,0x000018B9]

        self.toSpinQ.writePicture(toSpinPic,toSpinPic.__len__())
        self.toSpinQ.addConditionalTicks(5)

        if self.gotCommandFromSpinnaker:
            print "got command in wpts"
        else:
            print "dont got command in wpts"

        self.after(200,self.writePictureToSpin)


    #-----Functions for drawing
    def reDraw(self):
        self.canvas.delete(self.triangle1)
        self.canvas.delete(self.triangle2)
        self.canvas.delete(self.triangle3)
        self.canvas.delete(self.triangle4)
        self.drawPyramid()
        

    def drawFace(self,point1,point2,point3,fc):
        #translate to camera = 0,0,0 coordinates
        p1 = point1-self.camera
        p2 = point2-self.camera
        p3 = point3-self.camera

        #rotate 
        p1 = np.dot(self.translationMatrix,p1)
        p2 = np.dot(self.translationMatrix,p2)
        p3 = np.dot(self.translationMatrix,p3)

        #print 'go', p1,p2,p3,self.camera


        #project onto camera
        if (p1[2] == 0) or (p2[2] == 0) or (p3[2] == 0):
            print 'ho', p1,p2
            return


        #project onto 2D
        fovealLength = 100 #this makes the triangles look odd at the edges.

        distP1 = fovealLength/p1[2]
        distP2 = fovealLength/p2[2]
        distP3 = fovealLength/p3[2]


        if (distP1 < 0) or (distP2 < 0) or (distP3 < 0):
            return

        distP1 = abs(distP1)
        distP2 = abs(distP2)
        distP3 = abs(distP3)

        p1 = p1*distP1
        p2 = p2*distP2
        p3 = p3*distP3
        
        #move to the centre of the picture
        offset = np.array([250,250,0,0])
        p1=p1 + offset
        p2=p2 + offset
        p3=p3 + offset

        points = [p1[0], p1[1],p2[0], p2[1], p3[0], p3[1]]

#        triangle = self.canvas.create_polygon(points, outline='red', 
        triangle = self.canvas.create_polygon(points, outline='black', 
                                              fill=fc, width=2)
        return triangle
        
    def drawPyramid(self):
        self.triangle1 = self.drawFace(self.pyrP1,self.pyrP2, self.pyrP5,
                                      'black')
        self.triangle2 = self.drawFace(self.pyrP2,self.pyrP3, self.pyrP5,
                                      'black')
#                                       'green')
        self.triangle3 = self.drawFace(self.pyrP3,self.pyrP4, self.pyrP5,
                                      'black')
#                                       'blue')
        self.triangle4 = self.drawFace(self.pyrP4,self.pyrP1, self.pyrP5,
                                      'black')
#                                       'yellow')
        
    def inside(self,newCamera):
        if (newCamera[0] >= self.pyrP1[0]) and (newCamera[0] <= self.pyrP3[0]) and (newCamera[2] >= self.pyrP1[2]) and (newCamera[2] <= self.pyrP3[2]):
            return True
        return False
        
    #-----Functions for moving
    def move (self, tempCamera,distance):
        tempCamera[2] += distance * math.cos(self.direction)
        tempCamera[0] += distance * -math.sin(self.direction)
        return tempCamera

    def moveForward(self):
        print "move forward"
        temp = np.array(self.camera)
        temp = self.move(temp,50)
        if self.inside(temp):
            print "bump"
            self.putTextInFile("bump")
            return
        self.camera = temp
        self.reDraw()
        #print self.direction, self.camera[0], self.camera[2]

    def moveBack(self):
        print "move back"
        temp = np.array(self.camera)
        temp = self.move(temp,-47)
        if self.inside(temp):
            print "bump"
            return
        self.camera = temp
        self.reDraw()


    def setRotation(self):
        self.translationMatrix[0,0] = math.cos(self.direction)
        self.translationMatrix[0,2] = math.sin(self.direction)
        self.translationMatrix[2,0] = -math.sin(self.direction)
        self.translationMatrix[2,2] = math.cos(self.direction)
        print self.direction 

    def turnRight (self):
        print "turn right"
        self.direction -= 0.19
        self.direction = self.direction % 6.28
        self.setRotation()
        self.reDraw()

    def turnLeft (self):
        print "turn left"
        self.direction += 0.17
        self.direction = self.direction % 6.28
        self.setRotation()
        self.reDraw()

    def reset(self):
        self.direction = 0.0
        self.camera = np.array([150.0,300.0,0.0,1.0])
        self.reDraw()


    def keyHandler(self,event):
        #print "keyhandler", repr(event.char)
        if (event.char == '\r'):
            text = self.editBox.get(1.0,END)
            self.editBox.delete(1.0,END)
            self.processTextInput(text)
            self.putTextInFile(text)

    def initUI(self):
        self.parent.title("Shapes")        
        self.pack(fill=BOTH, expand=1)

        self.canvas = Canvas(self)
            
        self.drawPyramid()
        self.canvas.pack(fill=BOTH, expand=1)

        quitButton = Button(self, text="Quit",
            command=self.quit)
        quitButton.place(x=0, y=0)

        forwardButton = Button(self, text="Forward", command=self.forward)
        forwardButton.place(x=70, y=0)
        backButton = Button(self, text="Back", command=self.back)
        backButton.place(x=140, y=0)
        leftButton = Button(self, text="Left", command=self.left)
        leftButton.place(x=210, y=0)
        rightButton = Button(self, text="Right", command=self.right)
        rightButton.place(x=280, y=0)
        resetButton = Button(self, text="Reset", command=self.reset)
        resetButton.place(x=350, y=0)
        printButton = Button(self, text="Print", command=self.dumpJPG)
        printButton.place(x=420, y=0)
        self.editBox = Text(self,height=1, width=50)
        self.editBox.place(x=0, y=25)
        self.editBox.bind("<Key>",self.keyHandler)

        printButton.after(1000,self.readFromSpin) #setup a timer callback
        printButton.after(10,self.writePictureToSpin) 

def main():
    root = Tk()
    ex = Environment(root)
    ex.toSpinQ = spikeQueue()
    #ex.toSpinQ.addConditionalTicks(5000)
    ex.imageTranslator = imageToPixelClass(INPSIZE)
    root.geometry("500x500+300+300")
    #root.geometry("600x500+300+300")
    root.mainloop()  


if __name__ == '__main__':
    main()  
