"""
Parsing class with functions to create and run parsing.
It's really just a big FSA to deal with all the sentences.  The final
state is unique for each sentence considered.
It's tested by messing about with setInputs words.
You can see the output in the results/AllStates.sp file.
If you tail it, it should end with the neurons for the final 
state  (see sentence = at the beginning of the class)
Turn left.
Turn right.
Move forward.
Move back.
Move left. 
Move right.
Turn toward the pyramid.
Turn toward the stalactite.
Go to the pyramid.
Go to the stalactite.
Centre the pyramid.
Centre the stalactite.
Explore.
Stop.
Go to the door.
Go to the striped pyramid. 
Go to the striped stalactite.
Go to the barred pyramid.
Go to the barred stalactite.
Move before the striped stalactite. 
Move before the barred stalactite.
Move before the striped pyramid. 
Move before the barred pyramid.

Words Back, Barred, Before, Centre (3)
Door, Explore, Forward, Go, Left (8)
Move, Period,  Pyramid, Right, Stalactite (13)
Stop, Striped, The,     To,    Toward (18)
Turn

States  Start, Turn, TurnLeft,TurnLeftP,  (3)
TurnRight, TurnRightP, TurnToward, TurnTowardThe, (7)
TurnTowardThePyramid, TurnTowardThePyramidP, TurnTowardTheStalactite, TurnTowardTheStalactiteP, 
Move, MoveForward, MoveForwardP,    MoveBack (15)
MoveBackP, MoveLeft, MoveLeftP,     MoveRight(19)
MoveRightP, MoveBefore, MoveBeforeThe,  MoveBeforeTheStriped (23)
MoveBeforeTheStripedStalactite, MoveBeforeTheStripedStalactiteP, MoveBeforeTheBarred, MoveBeforeTheBarredStalactite (27)
MoveBeforeTheBarredStalactiteP, MoveBeforeTheStripedPyramid, MoveBeforeTheStripedPyramidP, MoveBeforeTheBarredPyramid (31)
MoveBeforeTheBarredPyramidP, Go, GoTo, GoToThe (35)
GoToThePyramid, GoToThePyramidP,GoToTheStalactite, GoToTheStalactiteP (39)
GoToTheDoor, GoToTheDoorP, GoToTheStriped, GoToTheStripedPyramid (43)
GoToTheStripedPyramidP,GoToTheStripedStalactite,GoToTheStripedStalactiteP, GoToTheBarred (47)
GoToTheBarredPyramid, GoToTheBarredPyramidP,GoToTheBarredStalactite,GoToTheBarredStalactiteP (51)
Centre, CentreThe,CentreThePyramid, CentreThePyramidP (55)
CentreTheStalactite, CentreTheStalactiteP, Explore,  ExploreP (59)
Stop, StopP (61)


To add a new sentence,
    add a new word CA in allocateWords
    add new state CAs in allocateStates
    for this test, change inputs in setInputConnections
    make the word a CA in makeWordCAs
    make the state CAs in makeStateCAs
    make the state transitions in makeTransitions
    record
    print
"""

#imports for PyNN
from pyNN.utility import get_script_args
from pyNN.spiNNaker import *

#NEAL files and functions
from nealParams import *

class parseArea:

    sentence = "turn left." #3 19
    #sentence = "turn right." #5 29
    #sentence = "move forward." #14 74
    #sentence = "move back." #16 84
    #sentence = "move left." #18 94
    #sentence = "move right." #20 #104
    #sentence = "turn toward the pyramid." #9 49
    #sentence = "turn toward the stalactite." #11 59
    #sentence = "go to the pyramid." #37 189
    #sentence = "go to the stalactite." #39 199
    #sentence = "centre the stalactite." #57 289
    #sentence = "centre the pyramid." #55 279
    #sentence = "explore." #59 299
    #sentence = "stop." #61 309
    #sentence = "go to the door." #41 209
    #sentence = "go to the striped pyramid." #44 224
    #sentence = "go to the striped stalactite." #46 234
    #sentence = "go to the barred pyramid." #49 249
    #sentence = "go to the barred stalactite." #51 259
    #sentence = "move before the striped stalactite."
    #sentence = "move before the barred stalactite."
    #sentence = "move before the striped pyramid." 
    #sentence = "move before the barred pyramid."

    NUMBER_WORDS = 21
    NUMBER_STATES = 62

    def __init__(self, simName):
        self.simulator_name = simName

    #----helper functions
    def nealProjection(self,preNeurons,postNeurons, connectorList,inhExc):
        if self.simulator_name == 'spiNNaker':
            Projection(preNeurons, postNeurons, connectorList,target=inhExc)
        elif self.simulator_name == 'nest':
            Projection(preNeurons, postNeurons, connectorList)
        else:
            print 'bad simulator for nealProjection'

    def makeCASynapses(self,CAsCells,numberCAs):
        synWeight = 25.0
        connector = []
        for cCA in range (0,numberCAs):
            for fromOff in range (0,5):
                for toOff in range (0,5):
                    if (fromOff != toOff):
                        fromNeuron = cCA*5+fromOff
                        toNeuron = cCA*5+toOff
                        connector=connector+[(fromNeuron,toNeuron,synWeight,
                                              DELAY)]
        excConnector = FromListConnector(connector)
        self.nealProjection(CAsCells,CAsCells, excConnector,'excitatory')

    #connect word to state
    def connectWordCAToStateCA(self,wordCells,fromNum,stateCells,toNum,synWeight):
        connector = []
        for fromOff in range (0,5):
            for toOff in range (0,5):
                fromNeuron = fromNum*5 + fromOff
                toNeuron = toNum*5 + toOff
                connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
        excConnector = FromListConnector(connector)
        self.nealProjection(wordCells,stateCells, excConnector,'excitatory')

    #connect state to state
    def connectStateCAToStateCA(self,stateCells,fromNum,toNum,synWeight):
        connector = []
        for fromOff in range (0,5):
            for toOff in range (0,5):
                fromNeuron = fromNum*5 + fromOff
                toNeuron = toNum*5 + toOff
                connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
        excConnector = FromListConnector(connector)
        self.nealProjection(stateCells,stateCells, excConnector,'excitatory')

    #state stops word
    def StateCAStopsWordCA(self,stateCells, fromNum, wordCells, toNum):
        synWeight = -10.0
        connector = []
        for fromOff in range (0,5):
            for toOff in range (0,5):
                fromNeuron = fromNum*5+fromOff
                toNeuron = toNum*5 + toOff
                connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
                inhConnector = FromListConnector(connector)
        self.nealProjection(stateCells,wordCells, inhConnector,'inhibitory')

    #state stops state
    def StateCAStopsStateCA(self,stateCells, fromNum,toNum):
        synWeight = -10.0
        connector = []
        for fromOff in range (0,5):
            for toOff in range (0,5):
                fromNeuron = fromNum*5 + fromOff
                toNeuron = toNum*5 + toOff
                connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
                inhConnector = FromListConnector(connector)
        self.nealProjection(stateCells,stateCells, inhConnector,'inhibitory')

    def CAStopsCA2(self,fromCA,toCA,toNum):
        synWeight = -10.0
        connector = []
        for fromNeuron in range (0,5):
            for toOff in range (0,5):
                toNeuron = toNum*5 + toOff
                connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
                inhConnector = FromListConnector(connector)
        self.nealProjection(fromCA,toCA, inhConnector,'inhibitory')

    def CAStopsCA(self,fromCA,toCA):
        synWeight = -10.0
        connector = []
        for fromNeuron in range (0,5):
            for toNeuron in range (0,5):
                connector=connector+[(fromNeuron,toNeuron,synWeight,DELAY)]
                inhConnector = FromListConnector(connector)
        self.nealProjection(fromCA,toCA, inhConnector,'inhibitory')

    #-----functions called externally and their subfunctions
    #---create the neurons for the CAs
    def allocateWords(self):
        cell_params = {'tau_refrac' : 3.0, 'v_rest' : -65.0,
               'v_thresh' : -51.0,  'tau_syn_E'  : 2.0, 
               'tau_syn_I': 5.0,    'v_reset'    : -70.0, 
               'i_offset' : 0.0}
#               'i_offset' : 0.1}  undone why does this work in standalone parse but not here?
        
        self.WordsCells=Population(self.NUMBER_WORDS*5,IF_curr_exp,cell_params)

    def allocateStates(self):
        cell_params = {'tau_refrac' : 3.0, 'v_rest' : -65.0,
               'v_thresh' : -51.0,  'tau_syn_E'  : 2.0, 
               'tau_syn_I': 5.0,    'v_reset'    : -70.0, 
               'i_offset' : 0.0}
#               'i_offset' : 0.1}

        self.StatesCells=Population(self.NUMBER_STATES*5,IF_curr_exp,cell_params)

    def allocateParseNeurons(self):
        self.allocateWords()
        self.allocateStates()


    def setSpikeServerInputs(self):
        self.InputWordSource=Population(24,SpikeSource,{},label="wordInputs")
        self.InputWordSource.set_mapping_constraint({'x':0, 'y':0, 'p': 1})


    def setInputs(self):
        spikes = [[57]]
        self.inputSource1=Population(1,SpikeSourceArray,{'spike_times':spikes})
        spikes = [[100]]
        self.inputSource2=Population(1,SpikeSourceArray,{'spike_times':spikes})
        spikes = [[150]]
        self.inputSource3=Population(1,SpikeSourceArray,{'spike_times':spikes})
        spikes = [[200]]
        self.inputSource4=Population(1,SpikeSourceArray,{'spike_times':spikes})
        spikes = [[250]]
        self.inputSource5=Population(1,SpikeSourceArray,{'spike_times':spikes})
        spikes = [[300]]
        self.inputSource6=Population(1,SpikeSourceArray,{'spike_times':spikes})
        spikes = [[350]]
        self.inputSource7=Population(1,SpikeSourceArray,{'spike_times':spikes})


    def setSentence(self):
        if (self.sentence=="turn left."):
            self.words = 3
            self.word1 = 19 
            self.word2 = 8
            self.word3 = 10
        elif (self.sentence=="turn right."):
            self.words = 3
            self.word1 = 19
            self.word2 = 12
            self.word3 = 10
        elif (self.sentence=="move forward."):
            self.words = 3
            self.word1 = 9
            self.word2 = 6
            self.word3 = 10
        elif (self.sentence=="move back."):
            self.words = 3
            self.word1 = 9
            self.word2 = 0
            self.word3 = 10
        elif (self.sentence=="move left."):
            self.words = 3
            self.word1 = 9
            self.word2 = 8
            self.word3 = 10
        elif (self.sentence=="move right."):
            self.words = 3
            self.word1 = 9
            self.word2 = 12
            self.word3 = 10
        elif (self.sentence=="turn toward the pyramid."):
            self.words = 5
            self.word1 = 19
            self.word2 = 18
            self.word3 = 16
            self.word4 = 11
            self.word5 = 10
        elif (self.sentence=="turn toward the stalactite."):
            self.words = 5
            self.word1 = 19
            self.word2 = 18
            self.word3 = 16
            self.word4 = 13
            self.word5 = 10
        elif (self.sentence=="go to the pyramid."):
            self.words = 5
            self.word1 = 7
            self.word2 = 17
            self.word3 = 16
            self.word4 = 11
            self.word5 = 10
        elif (self.sentence=="go to the stalactite."):
            self.words = 5
            self.word1 = 7
            self.word2 = 17
            self.word3 = 16
            self.word4 = 13
            self.word5 = 10
        elif (self.sentence=="centre the stalactite."):
            self.words = 4
            self.word1 = 3
            self.word2 = 16
            self.word3 = 13
            self.word4 = 10
        elif (self.sentence=="centre the pyramid."):
            self.words = 4
            self.word1 = 3
            self.word2 = 16
            self.word3 = 11
            self.word4 = 10
        elif (self.sentence=="explore."):            
            self.words = 2
            self.word1 = 5
            self.word2 = 10
        elif (self.sentence=="stop."):            
            self.words = 2
            self.word1 = 14
            self.word2 = 10
        elif (self.sentence=="go to the door."):
            self.words = 5
            self.word1 = 7
            self.word2 = 17
            self.word3 = 16
            self.word4 = 4
            self.word5 = 10
        elif (self.sentence=="go to the striped pyramid."):
            self.words = 6
            self.word1 = 7
            self.word2 = 17
            self.word3 = 16
            self.word4 = 15
            self.word5 = 11
            self.word6 = 10
        elif (self.sentence=="go to the striped stalactite."):
            self.words = 6
            self.word1 = 7
            self.word2 = 17
            self.word3 = 16
            self.word4 = 15
            self.word5 = 13
            self.word6 = 10
        elif (self.sentence=="go to the barred pyramid."):
            self.words = 6
            self.word1 = 7
            self.word2 = 17
            self.word3 = 16
            self.word4 = 1
            self.word5 = 11
            self.word6 = 10
        elif (self.sentence=="go to the barred stalactite."):
            self.words = 6
            self.word1 = 7
            self.word2 = 17
            self.word3 = 16
            self.word4 = 1
            self.word5 = 13
            self.word6 = 10
        elif (self.sentence=="move before the striped stalactite."):
            self.words = 6
            self.word1 = 9
            self.word2 = 2
            self.word3 = 16
            self.word4 = 15
            self.word5 = 13
            self.word6 = 10
        elif (self.sentence=="move before the barred stalactite."):
            self.words = 6
            self.word1 = 9
            self.word2 = 2
            self.word3 = 16
            self.word4 = 1
            self.word5 = 13
            self.word6 = 10
        elif (self.sentence=="move before the striped pyramid."):
            self.words = 6
            self.word1 = 9
            self.word2 = 2
            self.word3 = 16
            self.word4 = 15
            self.word5 = 11
            self.word6 = 10
        elif (self.sentence=="move before the barred pyramid."):
            self.words = 6
            self.word1 = 9
            self.word2 = 2
            self.word3 = 16
            self.word4 = 1
            self.word5 = 11
            self.word6 = 10
        else:
            print "bad sentence"

    #----Make Synapses
    #The start state, and each word have an input connection
    #link those to the appropriate (state) words
    def setSpikeServerInputConnections(self):
        synWeight = 20.0
        connector = []
        #set the start state
        for toNeuron in range (0,5):
            connector=connector+[(1,toNeuron,synWeight,DELAY)]
        excConnector = FromListConnector(connector) 
        self.nealProjection(self.InputWordSource,self.StatesCells,
                            excConnector,'excitatory') #start is the 1st state

        #connect the input source to each word
        connector = []
        for word in range (0,(self.NUMBER_WORDS)):
            for toOff in range (0,5):
                toNeuron = word*5 + toOff
                connector=connector+[(word+2,toNeuron,synWeight,DELAY)]
        excConnector = FromListConnector(connector) 
        self.nealProjection(self.InputWordSource,self.WordsCells,
                            excConnector,'excitatory') 

    def setInputConnections(self):
        self.setSentence()
        synWeight = 20.0
        connector = []
        for toNeuron in range (0,5):
            connector=connector+[(0,toNeuron,synWeight,DELAY)]
        excConnector = FromListConnector(connector) 
        self.nealProjection(self.inputSource1,self.StatesCells,
                            excConnector,'excitatory') #start is the 1st state

        connector = []
        for toOff in range (0,5):
            toNeuron = self.word1*5 + toOff
            connector=connector+[(0,toNeuron,synWeight,DELAY)]
        excConnector = FromListConnector(connector) 
        self.nealProjection(self.inputSource2,self.WordsCells,excConnector,
                            'excitatory')

        connector = []
        for toOff in range (0,5):
            toNeuron = self.word2*5 + toOff
            connector=connector+[(0,toNeuron,synWeight,DELAY)]
        excConnector = FromListConnector(connector) 
        self.nealProjection(self.inputSource3,self.WordsCells,excConnector,
                            'excitatory')
        connector = []
        if (self.words >= 3):
            for toOff in range (0,5):
                toNeuron = self.word3*5 + toOff
                connector=connector+[(0,toNeuron,synWeight,DELAY)]
            excConnector = FromListConnector(connector) 
            self.nealProjection(self.inputSource4,self.WordsCells,excConnector,
                            'excitatory')
        connector = []
        if (self.words >= 4):
            for toOff in range (0,5):
                toNeuron = self.word4*5 + toOff
                connector=connector+[(0,toNeuron,synWeight,DELAY)]
            excConnector = FromListConnector(connector) 
            self.nealProjection(self.inputSource5,self.WordsCells,excConnector,
                            'excitatory')
        connector = []
        if (self.words >= 5):
            for toOff in range (0,5):
                toNeuron = self.word5*5 + toOff
                connector=connector+[(0,toNeuron,synWeight,DELAY)]
            excConnector = FromListConnector(connector) 
            self.nealProjection(self.inputSource6,self.WordsCells,excConnector,
                            'excitatory')
        connector = []
        if (self.words >= 6):
            for toOff in range (0,5):
                toNeuron = self.word6*5 + toOff
                connector=connector+[(0,toNeuron,synWeight,DELAY)]
            excConnector = FromListConnector(connector) 
            self.nealProjection(self.inputSource7,self.WordsCells,excConnector,
                            'excitatory')


    def makeWordCAs(self):
        self.makeCASynapses(self.WordsCells,self.NUMBER_WORDS)


    def makeStateCAs(self):
        self.makeCASynapses(self.StatesCells,self.NUMBER_STATES)

    #Use a state and an input to change states.
    def makeTransition(self,statesCells,preNum,wordsCells,wordNum,postNum):
        #self.connectStateCAToStateCA(statesCells,preNum,postNum,0.2)
        #self.connectStateCAToStateCA(statesCells,preNum,postNum,0.02)
        self.connectStateCAToStateCA(statesCells,preNum,postNum,0.2)
        self.StateCAStopsStateCA(statesCells,postNum,preNum)
        #self.connectWordCAToStateCA(wordsCells,wordNum,statesCells,postNum,0.2)
        #self.connectWordCAToStateCA(wordsCells,wordNum,statesCells,postNum,0.02)
        self.connectWordCAToStateCA(wordsCells,wordNum,statesCells,postNum,0.3)
        self.StateCAStopsWordCA(statesCells,postNum,wordsCells,wordNum)


    def makeTransitions(self):
        #turn
        self.makeTransition(self.StatesCells,0,self.WordsCells,19,1)

        #turn LEFT.
        self.makeTransition(self.StatesCells,1,self.WordsCells,8,2)
        self.makeTransition(self.StatesCells,2,self.WordsCells,10,3)

        #turn RIGHT.
        self.makeTransition(self.StatesCells,1,self.WordsCells,12,4)
        self.makeTransition(self.StatesCells,4,self.WordsCells,10,5)

        #turn TOWARD THE
        self.makeTransition(self.StatesCells,1,self.WordsCells,18,6)
        self.makeTransition(self.StatesCells,6,self.WordsCells,16,7)

        #turn toward the PYRAMID.
        self.makeTransition(self.StatesCells,7,self.WordsCells,11,8)
        self.makeTransition(self.StatesCells,8,self.WordsCells,10,9)

        #turn toward the STALACTITE.
        self.makeTransition(self.StatesCells,7,self.WordsCells,13,10)
        self.makeTransition(self.StatesCells,10,self.WordsCells,10,11)

        #move
        self.makeTransition(self.StatesCells,0,self.WordsCells,9,12)

        #move FORWARD.
        self.makeTransition(self.StatesCells,12,self.WordsCells,6,13)
        self.makeTransition(self.StatesCells,13,self.WordsCells,10,14)
        #move BACK.
        self.makeTransition(self.StatesCells,12,self.WordsCells, 0,15)
        self.makeTransition(self.StatesCells,15,self.WordsCells,10,16)
        #move LEFT.
        self.makeTransition(self.StatesCells,12,self.WordsCells,8,17)
        self.makeTransition(self.StatesCells,17,self.WordsCells,10,18)
        #move RIGHT.
        self.makeTransition(self.StatesCells,12,self.WordsCells,12,19)
        self.makeTransition(self.StatesCells,19,self.WordsCells,10,20)

        #move BEFORE
        self.makeTransition(self.StatesCells,12,self.WordsCells,2,21)

        #move before THE STRIPED
        self.makeTransition(self.StatesCells,21,self.WordsCells,16,22)
        self.makeTransition(self.StatesCells,22,self.WordsCells,15,23)

        #move before the striped STALACTITE.
        self.makeTransition(self.StatesCells,23,self.WordsCells,13,24)
        self.makeTransition(self.StatesCells,24,self.WordsCells,10,25)

        #move before the BARRED
        self.makeTransition(self.StatesCells,22,self.WordsCells,1,26)

        #move before the barred STALACTITE.
        self.makeTransition(self.StatesCells,26,self.WordsCells,13,27)
        self.makeTransition(self.StatesCells,27,self.WordsCells,10,28)

        #move before the striped PYRAMID.
        self.makeTransition(self.StatesCells,23,self.WordsCells,11,29)
        self.makeTransition(self.StatesCells,29,self.WordsCells,10,30)

        #move before the barred PYRAMID.
        self.makeTransition(self.StatesCells,26,self.WordsCells,11,31)
        self.makeTransition(self.StatesCells,31,self.WordsCells,10,32)

        #GO TO THE
        self.makeTransition(self.StatesCells,0,self.WordsCells,7,33)
        self.makeTransition(self.StatesCells,33,self.WordsCells,17,34)
        self.makeTransition(self.StatesCells,34,self.WordsCells,16,35)

        #go to the PYRAMID.
        self.makeTransition(self.StatesCells,35,self.WordsCells,11,36)
        self.makeTransition(self.StatesCells,36,self.WordsCells,10,37)

        #go to the STALACTITE.
        self.makeTransition(self.StatesCells,35,self.WordsCells,13,38)
        self.makeTransition(self.StatesCells,38,self.WordsCells,10,39)

        #go to the DOOR.
        self.makeTransition(self.StatesCells,35,self.WordsCells,4,40)
        self.makeTransition(self.StatesCells,40,self.WordsCells,10,41)

        #go to the STRIPED
        self.makeTransition(self.StatesCells,35,self.WordsCells,15,42)
        #go to the striped PYRAMID.
        self.makeTransition(self.StatesCells,42,self.WordsCells,11,43)
        self.makeTransition(self.StatesCells,43,self.WordsCells,10,44)
        #go to the striped STALACTITE.
        self.makeTransition(self.StatesCells,42, self.WordsCells,13,45)
        self.makeTransition(self.StatesCells,45, self.WordsCells,10,46)
        #go to the BARRED
        self.makeTransition(self.StatesCells,35,self.WordsCells,1,47)

        #go to the barred PYRAMID.
        self.makeTransition(self.StatesCells,47,self.WordsCells,11,48)
        self.makeTransition(self.StatesCells,48,self.WordsCells,10,49)

        #go to the barred STALACTITE.
        self.makeTransition(self.StatesCells,47,self.WordsCells,13,50)
        self.makeTransition(self.StatesCells,50,self.WordsCells,10,51)

        #CENTRE THE
        self.makeTransition(self.StatesCells,0,self.WordsCells,3,52)
        self.makeTransition(self.StatesCells,52,self.WordsCells,16,53)

        #centre the PYRAMID.
        self.makeTransition(self.StatesCells,53,self.WordsCells,11,54)
        self.makeTransition(self.StatesCells,54,self.WordsCells,10,55)

        #centre the STALACTITE.
        self.makeTransition(self.StatesCells,53,self.WordsCells,13,56)
        self.makeTransition(self.StatesCells,56,self.WordsCells,10,57)

        #EXPLORE.
        self.makeTransition(self.StatesCells,0,self.WordsCells,5,58)
        self.makeTransition(self.StatesCells,58,self.WordsCells,10,59)

        #STOP.
        self.makeTransition(self.StatesCells,0,self.WordsCells,14,60)
        self.makeTransition(self.StatesCells,60,self.WordsCells,10,61)

    def setConnections(self):
        #self.setInputConnections()
        self.setSpikeServerInputConnections()
        self.makeWordCAs()
        self.makeStateCAs()
        self.makeTransitions()


    def setRecording(self):
        if self.simulator_name == 'spiNNaker':
            self.InputWordSource.record()
            #self.WordsCells.record()
            #self.StatesCells.record()

        elif self.simulator_name == 'nest':
            self.WordsCells.record('spikes')
            self.StatessCells.record('spikes')

    #-----printing
    def nestPrint(self,printText,CA):
            print printText
            outAssembly = Assembly(CA[(0,1)])
            outDat = outAssembly.get_data()
            for seg in outDat.segments:
                print(seg.spiketrains)
                #    print(seg.analogsignalarrays)
        
    def printWords(self):
        if self.simulator_name == 'spiNNaker':
            self.WordsCells.printSpikes('results/AllWords.sp')
            #self.LeftWordCells.printSpikes('results/leftWord.sp')
            #self.TurnWordCells.printSpikes('results/turnWord.sp')
            #self.RightWordCells.printSpikes('results/leftWord.sp')
            #self.PeriodWordCells.printSpikes('results/periodWord.sp')
        elif self.simulator_name == 'nest':
            print "nop"
            #self.nestPrint("Left Word",self.LeftWordCells[(0,1)])
            #self.nestPrint("Move Word",self.MoveWordCells[(0,1)])
            #self.nestPrint("Right Word",self.RightWordCells[(0,1)])
            #self.nestPrint("Turn Word",self.TurnWordCells[(0,1)])
            #self.nestPrint("Period Word",self.PeriodWordCells[(0,1)])

    def printStates(self):
        if self.simulator_name == 'spiNNaker':
            self.StatesCells.printSpikes('results/AllStates.sp')

        elif self.simulator_name == 'nest':
            print "nop"
            #self.nestPrint("Move Forward Period State",self.MoveForwardPStateCells[(0,1)])
            #self.nestPrint("Turn Toward The Pyramid Period State",self.TurnTowardThePyramidPStateCells[(0,1)])
            #self.nestPrint("Turn Toward The Stalactite Period State",self.TurnTowardTheStalactitePStateCells[(0,1)])
            

    def printResults(self):
        self.printWords()
        self.printStates()

    def getStates(self):
        return self.StatesCells
