#!/usr/bin/python
"""
This is for reading from the spike server, and thus the spinnaker board's
output.  It looks to see if it contains a legitimate command.  If so,
it writes a new file with that command.  The environment needs to 
read that command and process it.
"""
import time 
import sys
import os
import errno

def writeCommandFile(command):
    global numFiles
    fileName = "data/fromCABot2" + str(numFiles) + ".txt"
    fileOut = open (fileName,"wt")
    fileOut.write(str(command))
    fileOut.close()
    numFiles = numFiles + 1

def writeBinFile(byteString):
    global numLine
    fileName = "data/fromCABot2" + str(numLine) + ".bin"
    fileOut = open (fileName,"wb")
    fileOut.write(byteString)
    fileOut.close()

def writeBin2File(byteString):
    global numLine
    fileName = "data/fromCABot2Orig" + str(numLine) + ".bin"
    fileOut = open (fileName,"wb")
    fileOut.write(byteString)
    fileOut.close()

#The Pipe doesn't necessarily send 16 bytes at a time.  Keep the leftover 
#bytes and prepend them to the next line.
def make16ByteLine(byteString):
    global extraBytes
    newLine = extraBytes+byteString
    length = newLine.__len__()
    numExtraBytes = length%16
    sbLength = length - numExtraBytes
    sixteenByteLine = newLine[0:sbLength]
    if (numExtraBytes > 0): 
        extraBytes = newLine[sbLength:length]
    else:
        extraBytes = ""
    return sixteenByteLine
                          

def checkForAction(byteString):
    length = byteString.__len__()
    numPairWords = length/8
    for spikeTimePair in range (0, numPairWords):
        offset = spikeTimePair*8
        #print hex(ord(byteString[offset+4:offset+5])) 

        
        #if byteString[offset+5:offset+7] == 'P\x01': #x0001500?
        if byteString[offset+5:offset+8] == '\x08\x00\x01': #x0100080?
            if byteString[offset+4] == '\x00':
                #print "right"
                return 0
            elif byteString[offset+4] == '\x01':
                print "left"
                return 1
            elif byteString[offset+4] == '\x02':
                #print "forward"
                return 2
            elif byteString[offset+4] == '\x03':
                #print "back"
                return 3
            else:
                print "something odd from action"

    return -1 #no action

def processLine(byteString):
    command = checkForAction(byteString)
    if (command >= 0):
        writeCommandFile(command)
    

numFiles = 0
numLine = 0
extraBytes = ""
line = ""
inFile = os.open("cb2ToEnvPipe",os.O_RDONLY|os.O_NONBLOCK)
#while numLine < 500000:
while True:
    try:
        line = ""
        line = os.read(inFile,16)
    except OSError as esc:
        if esc.errno==errno.EAGAIN:
            line = ""

    if (line.__len__() > 0):
        #print time.time()
        #print line,numLine
        newLine = make16ByteLine(line)
        processLine(newLine)
        if (newLine.__len__() > 0):
            writeBinFile(newLine)
            numLine = numLine + 1
os.close(inFile)

    
"""
for line in sys.stdin:
    #writeBin2File(line)
    newLine = make16ByteLine(line)
    processLine(newLine)
    writeBinFile(newLine)
    numLine = numLine + 1
"""
